## tigervnc 1.11.0+dfsg

=== po/CMakeLists.txt ===
# Gettext support - mostly borrowed from the Licq project

file(STRINGS LINGUAS po_FILES)

if (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)
  message(FATAL_ERROR "Gettext message catalog tools NOT found")
endif (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if (GETTEXT_XGETTEXT_EXECUTABLE)
  # Get list of all source files
  file(GLOB_RECURSE po_source
    RELATIVE ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/vncviewer/*.h
    ${PROJECT_SOURCE_DIR}/vncviewer/*.cxx
    ${PROJECT_SOURCE_DIR}/vncviewer/*.desktop.in.in
  )

  add_custom_target(translations_update
    ${GETTEXT_XGETTEXT_EXECUTABLE}
      "--directory=${PROJECT_SOURCE_DIR}"
      "--output=${CMAKE_CURRENT_SOURCE_DIR}/tigervnc.pot"
      --default-domain=tigervnc
      --keyword=_
      --keyword=p_:1c,2
      --keyword=N_
      "--copyright-holder=TigerVNC Team and many others \(see README.rst\)"
      --msgid-bugs-address=tigervnc-devel@googlegroups.com
      --sort-by-file
      --add-location
      --add-comments=TRANSLATORS
      ${po_source}
    COMMENT "Updating tigervnc.pot"
    VERBATIM
  )
endif (GETTEXT_XGETTEXT_EXECUTABLE)

foreach(lang ${po_FILES})
  set(po  "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
  set(mo "${CMAKE_CURRENT_BINARY_DIR}/${lang}.mo")

  # Add command to build X.mo from X.po
  add_custom_command(OUTPUT ${mo}
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${mo} ${po}
    DEPENDS ${po}
  )

  install(FILES ${mo}
    DESTINATION "${CMAKE_INSTALL_FULL_LOCALEDIR}/${lang}/LC_MESSAGES"
    RENAME tigervnc.mo
  )

  set(moFiles ${moFiles} ${mo})
endforeach(lang)

add_custom_target(translations ALL DEPENDS ${moFiles})

=== debian/changelog ===
tigervnc (1.11.0+dfsg-2ubuntu0.1) hirsute; urgency=medium

  * debian/patch/0001-Update-Surface_X11.cxx.patch
    TigerVNC 1.11.0 contains a regression that causes vncviewer to display
    incorrect colors when vncviewer and X11 server use different endianness.
    (LP: #1929790)

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 20 Sep 2021 20:41:22 +0200

tigervnc (1.11.0+dfsg-2) unstable; urgency=medium

  [ Joachim Falk ]
  * Properly handle boolean configuration values in tigervnc-standalone-server
    (Closes: #985614).

 -- Joachim Falk <joachim.falk@gmx.de>  Mon, 22 Mar 2021 22:21:54 +0100

tigervnc (1.11.0+dfsg-1) unstable; urgency=medium

  [ Joachim Falk ]
  * Fresh upstream TigerVNC 1.11.0 (Closes: #976002).

  [ Debian Janitor ]
  * Use correct machine-readable copyright file URI.
  * Fix field name case in debian/copyright (COpyright => Copyright).
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Joachim Falk <joachim.falk@gmx.de>  Mon, 22 Feb 2021 18:19:01 +0100

tigervnc (1.10.1+dfsg-9) unstable; urgency=medium

  [ Joachim Falk ]
  * Properly store certificate exceptions in native and java VNC viewer. The
    VNC viewers stored the certificate exceptions as authorities, meaning that
    the owner of a certificate could impersonate any server after a client had
    added an exception. This is issue CVE-2020-26117 (Closes: #971272).

 -- Joachim Falk <joachim.falk@gmx.de>  Mon, 28 Sep 2020 22:43:11 +0200

tigervnc (1.10.1+dfsg-8) unstable; urgency=medium

  [ Antoni Villalonga ]
  * Removed unrequired pristine-tar build dependency
  * Add Antoni Villalonga as Uploader

  [ Joachim Falk ]
  * Handle /etc/default/keyboard configuration.
  * Small tweaks to tigervncserver(1) man page.
  * New $session argument in vnc.conf to specify the X session to start.
  * Improved documentation of vnc.conf.

 -- Joachim Falk <joachim.falk@gmx.de>  Sat, 26 Sep 2020 01:42:30 +0200

tigervnc (1.10.1+dfsg-7) unstable; urgency=medium

  [ Joachim Falk ]
  * Fixed tigervnc-xorg-extension (/usr/lib/xorg/modules/extensions/libvnc.so)
    by reapplying Debian specific libtool work around to link against all
    libtool dependency libs of libvnc.so (Closes: #966238).

 -- Joachim Falk <joachim.falk@gmx.de>  Thu, 30 Jul 2020 00:09:05 +0200

tigervnc (1.10.1+dfsg-6) unstable; urgency=medium

  [ Joachim Falk ]
  * Hopefully fixed package builds using targets build-arch and build-indep.

 -- Joachim Falk <joachim.falk@gmx.de>  Mon, 13 Jul 2020 18:09:14 +0200

tigervnc (1.10.1+dfsg-5) unstable; urgency=medium

  [ Joachim Falk ]
  * Fixing lintian errors and warnings
  * Switched away from CDBS to a pure debhelper build system.
  * New try to enable reproducible builds for TigerVNC (Closes: #865753).

 -- Joachim Falk <joachim.falk@gmx.de>  Fri, 10 Jul 2020 17:25:13 +0200

tigervnc (1.10.1+dfsg-4) unstable; urgency=medium

  [ Joachim Falk ]
  * Remove Liang Guo <guoliang@debian.org> from uploaders (Closes: #961610).
  * Don't use libunwind for armel, armhf, and arm64 as this library is buggy
    (bug #923962) on those architectures (Closes: #932499).

 -- Joachim Falk <joachim.falk@gmx.de>  Tue, 16 Jun 2020 19:32:44 +0200

=== debian/control ===
Source: tigervnc
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: TigerVNC Packaging Team <pkg-tigervnc-devel@lists.alioth.debian.org>
Uploaders:
 Joachim Falk <joachim.falk@gmx.de>,
 Mike Gabriel <sunweaver@debian.org>,
 Yaroslav Halchenko <debian@onerussian.com>,
 Ola Lundqvist <opal@debian.org>,
 Antoni Villalonga <antoni@friki.cat>
# all the Build-Depends up to x11proto-xf86-dri-dev are for the normal Xorg
# server, and common dependencies for the DIX.
# x11proto-xf86dri-dev and libdrm-dev are for DRI support for the Xorg server.
# x11proto-print-dev and libfreetype6-dev are for Xprint
# everything on is for the DMX and Xnest servers.
Build-Depends:
 debhelper-compat (= 12),
 cmake (>= 2.8),
 gettext,
 zlib1g-dev,
 libjpeg-dev,
 libgnutls28-dev,
 libpam0g-dev,
 libxft-dev,
 libxcursor-dev,
 libxrandr-dev,
 libxdamage-dev,
 libwrap0-dev,
 libfltk1.3-dev (>= 1.3.3),
 xorg-server-source (>= 2:1.20),
 xserver-xorg-dev,
# this are dependencies from xorg-server-1.20.3 source deb
# debhelper (>= 10),
 po-debconf,
 dpkg-dev (>= 1.16.1),
 quilt,
 lsb-release,
 pkg-config,
 bison,
 flex,
 xutils-dev (>= 1:7.6+4),
 xfonts-utils (>= 1:7.5+1),
 x11proto-dev (>= 2018.4),
 xtrans-dev (>= 1.3.5),
 libxau-dev (>= 1:1.0.5-2),
 libxdmcp-dev (>= 1:0.99.1),
 libxfont-dev (>= 1:2.0.1),
 libxkbfile-dev (>= 1:0.99.1),
 libpixman-1-dev (>= 0.27.2),
 libpciaccess-dev (>= 0.12.901),
 libgcrypt-dev,
 nettle-dev,
 libudev-dev (>= 151-3) [linux-any],
 libselinux1-dev (>= 2.0.80) [linux-any],
 libaudit-dev [linux-any],
 libdrm-dev (>= 2.4.89) [!hurd-i386],
 libgl1-mesa-dev (>= 9.2),
# Don't use libunwind for armel, armhf, and arm64 as this library is buggy (bug #923962) on those architectures.
 libunwind-dev [amd64 hppa i386 ia64 mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el sh4],
 libxmuu-dev (>= 1:0.99.1),
 libxext-dev (>= 1:0.99.1),
 libx11-dev (>= 2:1.6),
 libxrender-dev (>= 1:0.9.0),
 libxi-dev (>= 2:1.6.99.1),
 libdmx-dev (>= 1:1.0.1),
 libxpm-dev (>= 1:3.5.3),
 libxaw7-dev (>= 1:0.99.1),
 libxt-dev (>= 1:0.99.1),
 libxmu-dev (>= 1:0.99.1),
 libxtst-dev (>= 1:0.99.1),
 libxres-dev (>= 1:0.99.1),
 libxfixes-dev (>= 1:3.0.0),
 libxv-dev,
 libxinerama-dev,
 libxshmfence-dev (>= 1.1) [!hurd-i386],
# glamor
 libepoxy-dev [linux-any kfreebsd-any],
 libegl1-mesa-dev [linux-any kfreebsd-any],
 libgbm-dev (>= 10.2) [linux-any kfreebsd-any],
## XCB bits for Xephyr
# libxcb1-dev,
# libxcb-xkb-dev,
# libxcb-shape0-dev,
# libxcb-render0-dev,
# libxcb-render-util0-dev,
# libxcb-util0-dev,
# libxcb-image0-dev,
# libxcb-icccm4-dev,
# libxcb-shm0-dev,
# libxcb-keysyms1-dev,
# libxcb-randr0-dev,
# libxcb-xv0-dev,
# libxcb-glx0-dev,
# libxcb-xf86dri0-dev (>= 1.6),
# unit tests
 xkb-data,
 x11-xkb-utils,
# arc4random_buf(), getpeereid()
 libbsd-dev,
## xwayland
# libwayland-dev [linux-any],
# wayland-protocols (>= 1.10) [linux-any],
#logind
  libdbus-1-dev (>= 1.0) [linux-any],
# systemd-daemon
  libsystemd-dev [linux-any],
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian-remote-team/tigervnc.git
Vcs-Browser: https://salsa.debian.org/debian-remote-team/tigervnc
Homepage: http://www.tigervnc.org

Package: tigervnc-common
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Breaks:
 tigervnc-server (<< 1.1.90),
 tigervnc-viewer (<< 1.1.90),
Replaces:
 tigervnc-server (<< 1.1.90),
 tigervnc-viewer (<< 1.1.90),
Description: Virtual network computing; Common software needed by servers
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 It is implemented in a client/server model. This package provides the
 vncpasswd and vncconfig tools as well as the common infrastructure for
 tigervnc-scraping-server and tigervnc-standalone-server packages.

Package: tigervnc-scraping-server
Architecture: any
Depends:
 tigervnc-common (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libfile-readbackwards-perl (>= 1.05)
Provides:
 vnc-server
Replaces: tigervnc-server (<< 1.1.90)
Breaks: tigervnc-server (<< 1.1.90)
Description: Virtual network computing server performing X screen scraping
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 This package provides a VNC server that perform screen scraping of an already
 running X server to provide its VNC desktop. The VNC desktop can be viewed
 by any VNC viewer even on other operating systems.
 .
 Note: If you only want to scrape your local X11 server, you should consider
 the tigervnc-xorg-extension package. This package provides the vnc extension
 for your local X11 server. The usage of this extension is more efficient
 than a scraping vnc server.

Package: tigervnc-standalone-server
Architecture: any
Depends:
 xkb-data,
 x11-xkb-utils,
 xauth,
 tigervnc-common (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libfile-readbackwards-perl (>= 1.05)
Recommends:
 libgl1-mesa-dri (>= 7.1~rc1),
 xfonts-base,
 x11-xserver-utils
Suggests:
 xfonts-100dpi | xfonts-75dpi,
 xfonts-scalable
Provides:
 vnc-server,
 xserver
Replaces: tigervnc-server (<< 1.1.90)
Breaks: tigervnc-server (<< 1.1.90)
Description: Standalone virtual network computing server
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 This package provides a standalone VNC server to which clients can connect.
 The server generates a display that can be viewed with a vncviewer.
 .
 Note: This server does not need a display. You need a VNC viewer to see
 something. This viewer may also be on a computer running other operating
 systems.

Package: tigervnc-xorg-extension
Architecture: any
Depends:
 xserver-xorg-core (>= 2:1.7.7),
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 tigervnc-common (= ${source:Version})
Provides:
 vnc-server,
 vnc-xorg-extension
Replaces: tigervnc-server (<< 1.1.90)
Breaks: tigervnc-server (<< 1.1.90)
Description: Virtual network computing X server extension
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 This package contains an X server connector so VNC clients can connect to your
 local X desktop directly.

Package: tigervnc-viewer
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 tigervnc-common (= ${source:Version})
Provides:
 vncviewer,
 vnc-viewer
Description: Virtual network computing client for X
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 This package provides a VNC client for X. With this you can connect to a
 VNC server and display its content. There are VNC servers available for other
 operating systems.

#Package: tigervnc-java
#Architecture: all
#Depends:
# openjdk-7-jre
#Provides:
# vnc-java-viewer
#Enhances:
# tigervnc-standalone-server
#Description: Virtual network computing java applet and command line program
# VNC stands for Virtual Network Computing. It is, in essence, a remote
# display system which allows you to view a computing `desktop' environment
# not only on the machine where it is running, but from anywhere on the
# Internet and from a wide variety of machine architectures.
# .
# It contains a java viewer implementation that can either be used as an applet,
# typically served by the built in web server provided by Xvnc
# (tigervnc-standalone-server) or from command line using a Java JRE.

## tigervnc 1.12.0%2Bdfsg

=== vncviewer/CMakeLists.txt ===
include_directories(${FLTK_INCLUDE_DIR})
include_directories(${GETTEXT_INCLUDE_DIR})

include_directories(${CMAKE_SOURCE_DIR}/common)
set(VNCVIEWER_SOURCES
  menukey.cxx
  BaseTouchHandler.cxx
  CConn.cxx
  DesktopWindow.cxx
  EmulateMB.cxx
  UserDialog.cxx
  ServerDialog.cxx
  Surface.cxx
  OptionsDialog.cxx
  PlatformPixelBuffer.cxx
  Viewport.cxx
  parameters.cxx
  keysym2ucs.c
  touch.cxx
  MonitorArrangement.cxx
  MonitorIndicesParameter.cxx
  vncviewer.cxx)

if(WIN32)
  # Since vncviewer.rc is generated, local includes will be looking
  # in the wrong directory. We need to help it out.
  include_directories(${CMAKE_CURRENT_SOURCE_DIR})
  configure_file(vncviewer.rc.in vncviewer.rc)
  set(VNCVIEWER_SOURCES
    ${VNCVIEWER_SOURCES}
    ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.rc)
endif()

if(WIN32)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Win32TouchHandler.cxx win32.c)
elseif(APPLE)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} cocoa.mm osx_to_qnum.c)
else()
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} GestureHandler.cxx XInputTouchHandler.cxx xkb_to_qnum.c)
endif()

if(WIN32)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Surface_Win32.cxx)
elseif(APPLE)
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Surface_OSX.cxx)
else()
  set(VNCVIEWER_SOURCES ${VNCVIEWER_SOURCES} Surface_X11.cxx)
endif()

if(WIN32 AND NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_executable(vncviewer WIN32 ${VNCVIEWER_SOURCES})
else()
  add_executable(vncviewer ${VNCVIEWER_SOURCES})
endif()

target_link_libraries(vncviewer rfb network rdr os ${FLTK_LIBRARIES} ${GETTEXT_LIBRARIES})

if(WIN32)
  target_link_libraries(vncviewer msimg32)
elseif(APPLE)
  target_link_libraries(vncviewer "-framework Cocoa")
  target_link_libraries(vncviewer "-framework Carbon")
  target_link_libraries(vncviewer "-framework IOKit")
else()
  target_link_libraries(vncviewer ${X11_Xi_LIB})

  if(X11_Xrandr_LIB)
    add_definitions(-DHAVE_XRANDR)
    target_link_libraries(vncviewer ${X11_Xrandr_LIB})
  endif()
endif()

install(TARGETS vncviewer DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
if(UNIX)
  install(FILES vncviewer.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME vncviewer.1)

  configure_file(vncviewer.desktop.in.in vncviewer.desktop.in)
  find_program(INTLTOOL_MERGE_EXECUTABLE intltool-merge)
  if("${GETTEXT_VERSION_STRING}" VERSION_GREATER 0.18.99)
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
                --desktop --template vncviewer.desktop.in
                -d ${CMAKE_SOURCE_DIR}/po -o vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  elseif(INTLTOOL_MERGE_EXECUTABLE)
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND sed -e 's/^Name/_Name/'
                -e 's/^GenericName/_GenericName/'
                -e 's/^Comment/_Comment/'
                vncviewer.desktop.in > vncviewer.desktop.intl
      COMMAND ${INTLTOOL_MERGE_EXECUTABLE}
                -d ${CMAKE_SOURCE_DIR}/po
                vncviewer.desktop.intl vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  else()
    add_custom_command(OUTPUT vncviewer.desktop
      COMMAND cp vncviewer.desktop.in vncviewer.desktop
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop.in
    )
  endif()
  add_custom_target(desktop ALL DEPENDS vncviewer.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncviewer.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications)

  foreach(res 16 22 24 32 48)
    install(FILES ../media/icons/tigervnc_${res}.png DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${res}x${res}/apps RENAME tigervnc.png)
  endforeach()
  install(FILES ../media/icons/tigervnc.svg DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps)
endif()

## tigervnc 1.12.0+dfsg

=== java/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(tigervnc-java Java)
if(NOT VERSION)
  set(VERSION 1.12.0)
endif()

find_package(Java)

set(DEFAULT_JAVACFLAGS "-source 8 -target 8 -encoding UTF-8 -Xlint:all,-serial,-cast,-unchecked,-fallthrough,-dep-ann,-deprecation,-rawtypes")
set(JAVACFLAGS ${DEFAULT_JAVACFLAGS} CACHE STRING
  "Java compiler flags (Default: ${DEFAULT_JAVACFLAGS})")
message(STATUS "Java compiler flags = ${JAVACFLAGS}")

set(CLASSPATH com/tigervnc/vncviewer)
set(SRCDIR ${CMAKE_CURRENT_SOURCE_DIR})
set(BINDIR ${CMAKE_CURRENT_BINARY_DIR})
set(JAVA_KEYSTORE NOTFOUND CACHE STRING "URL of keystore location")
set(JAVA_KEYSTORE_TYPE "jks" CACHE STRING "Type of keystore (Default: \"jks\")")
set(JAVA_KEY_ALIAS NOTFOUND CACHE STRING "Alias for the keystore entry used to generate the signature")
set(JAVA_STOREPASS NOTFOUND CACHE STRING "Password required to access the keystore")
set(JAVA_KEYPASS NOTFOUND CACHE STRING "Password used to protect the private key of the specified keystore entry")
set(JAVA_TSA_URL NOTFOUND CACHE STRING "URL of Time Stamping Authority (TSA)")

if(NOT BUILD)
	STRING(TIMESTAMP BUILD "%Y%m%d" UTC)
endif()
STRING(TIMESTAMP JAVA_DATE "%Y-%m-%d" UTC)
STRING(TIMESTAMP JAVA_TIME "%H:%M:%S" UTC)

set(JAVA_SOURCES "")
set(JAVA_CLASSES "")

set(JSCH_CLASSNAMES
  DH
  DHEC256
  DHEC384
  DHEC521
  DHECN
  DHGEX256
  DHG1
  DHG14
  DHGEX
  ECDH
  JSch
  Session
  UserAuth
  UserAuthKeyboardInteractive
  UserAuthPassword
  UserAuthPublicKey
  UserAuthNone
  jce/AES128CBC
  jce/AES128CTR
  jce/AES192CBC
  jce/AES192CTR
  jce/AES256CBC
  jce/AES256CTR
  jce/ARCFOUR
  jce/ARCFOUR128
  jce/ARCFOUR256
  jce/BlowfishCBC
  jce/DH
	jce/ECDH256
	jce/ECDH384
	jce/ECDH521
	jce/ECDHN
  jce/HMAC
  jce/HMACMD5
  jce/HMACMD596
  jce/HMACSHA1
  jce/HMACSHA196
  jce/HMACSHA256
  jce/HMACSHA512
  jce/KeyPairGenDSA
  jce/KeyPairGenECDSA
  jce/KeyPairGenRSA
  jce/MD5
  jce/PBKDF
  jce/Random
  jce/SHA1
  jce/SHA256
  jce/SHA384
  jce/SHA512
  jce/SignatureDSA
  jce/SignatureECDSA
  jce/SignatureRSA
  jce/TripleDESCBC
  jce/TripleDESCTR
  jcraft/Compression
  jcraft/HMAC
  jcraft/HMACMD596
  jcraft/HMACMD5
  jcraft/HMACSHA196
  jcraft/HMACSHA1)

foreach(class ${JSCH_CLASSNAMES})
  set(JAVA_SOURCES ${JAVA_SOURCES} com/jcraft/jsch/${class}.java)
  set(JAVA_CLASSES ${JAVA_CLASSES}
    ${BINDIR}/com/jcraft/jsch/${class}.class)
endforeach()

file(GLOB DEPEND_SOURCES
  ${SRCDIR}/${CLASSPATH}/*.java
  ${SRCDIR}/com/tigervnc/rfb/*.java
  ${SRCDIR}/com/tigervnc/rdr/*.java
  ${SRCDIR}/com/tigervnc/network/*.java
  ${SRCDIR}/com/jcraft/jsch/*.java
  ${SRCDIR}/com/jcraft/jsch/jcraft/*.java
  ${SRCDIR}/com/jcraft/jsch/jgss/*.java
  ${SRCDIR}/com/jcraft/jzlib/*.java)

string(REGEX REPLACE " " ";" JAVACFLAGS "${JAVACFLAGS}")
add_custom_command(OUTPUT ${JAVA_CLASSES}
  DEPENDS ${JAVA_SOURCES} ${DEPEND_SOURCES}
  COMMAND ${JAVA_COMPILE}
  ARGS ${JAVACFLAGS} -sourcepath ${SRCDIR} -d ${BINDIR} 
    ${CLASSPATH}/VncViewer.java ${JAVA_SOURCES}
	WORKING_DIRECTORY ${SRCDIR})

configure_file(${CLASSPATH}/timestamp.in ${CLASSPATH}/timestamp)

if(NOT "${SRCDIR}" STREQUAL "${BINDIR}")

set(ICONS
tigervnc.ico
tigervnc.png
insecure.png
secure.png)

foreach(icon ${ICONS})
  add_custom_command(OUTPUT ${BINDIR}/${CLASSPATH}/${icon}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
      ${SRCDIR}/${CLASSPATH}/${icon} ${BINDIR}/${CLASSPATH}/${icon}
    DEPENDS ${SRCDIR}/${CLASSPATH}/${icon})
endforeach()

endif()

string(REGEX REPLACE "jar" "" Java_PATH ${Java_JAR_EXECUTABLE})
string(REGEX REPLACE ".exe" "" Java_PATH ${Java_PATH})

add_custom_command(OUTPUT VncViewer.jar
  DEPENDS ${JAVA_CLASSES}
    ${SRCDIR}/${CLASSPATH}/MANIFEST.MF
    ${BINDIR}/${CLASSPATH}/timestamp
    ${BINDIR}/${CLASSPATH}/tigervnc.ico
    ${BINDIR}/${CLASSPATH}/tigervnc.png
    ${BINDIR}/${CLASSPATH}/insecure.png
    ${BINDIR}/${CLASSPATH}/secure.png
  COMMAND ${JAVA_ARCHIVE}
  ARGS cfm VncViewer.jar
    ${SRCDIR}/${CLASSPATH}/MANIFEST.MF
    ${CLASSPATH}/timestamp
    ${CLASSPATH}/*.class
    com/tigervnc/rfb/*.class
    com/tigervnc/rdr/*.class
    com/tigervnc/network/*.class
    com/jcraft/jzlib/*.class
    com/jcraft/jsch/jcraft/*.class
    com/jcraft/jsch/jce/*.class
    com/jcraft/jsch/*.class
    com/tigervnc/vncviewer/*.png
    com/tigervnc/vncviewer/tigervnc.ico
  COMMAND ${CMAKE_COMMAND}
  ARGS -DJava_PATH=${Java_PATH} -DJAR_FILE=${BINDIR}/VncViewer.jar
    -DJAVA_KEYSTORE=${JAVA_KEYSTORE}
    -DJAVA_KEYSTORE_TYPE=${JAVA_KEYSTORE_TYPE}
    -DJAVA_STOREPASS=${JAVA_STOREPASS}
    -DJAVA_KEYPASS=${JAVA_KEYPASS}
    -DJAVA_KEY_ALIAS=${JAVA_KEY_ALIAS}
    -DJAVA_TSA_URL=${JAVA_TSA_URL}
    -P ${SRCDIR}/cmake/SignJar.cmake)

add_custom_target(java ALL DEPENDS VncViewer.jar)

=== common/rdr/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common ${ZLIB_INCLUDE_DIRS})

add_library(rdr STATIC
  BufferedInStream.cxx
  BufferedOutStream.cxx
  Exception.cxx
  FdInStream.cxx
  FdOutStream.cxx
  FileInStream.cxx
  HexInStream.cxx
  HexOutStream.cxx
  RandomStream.cxx
  TLSException.cxx
  TLSInStream.cxx
  TLSOutStream.cxx
  ZlibInStream.cxx
  ZlibOutStream.cxx)

set(RDR_LIBRARIES ${ZLIB_LIBRARIES} os)
if(GNUTLS_FOUND)
  set(RDR_LIBRARIES ${RDR_LIBRARIES} ${GNUTLS_LIBRARIES})
endif()
if(WIN32)
	set(RDR_LIBRARIES ${RDR_LIBRARIES} ws2_32)
endif()

target_link_libraries(rdr ${RDR_LIBRARIES})

if(UNIX)
  libtool_create_control_file(rdr)
endif()

=== tests/perf/CMakeLists.txt ===
include_directories(${GETTEXT_INCLUDE_DIR})

include_directories(${CMAKE_SOURCE_DIR}/common)

add_library(test_util STATIC util.cxx)

add_executable(convperf convperf.cxx)
target_link_libraries(convperf test_util rfb)

add_executable(decperf decperf.cxx)
target_link_libraries(decperf test_util rfb)

add_executable(encperf encperf.cxx)
target_link_libraries(encperf test_util rfb)

if (BUILD_VIEWER)
  include_directories(${FLTK_INCLUDE_DIR})
  set(FBPERF_SOURCES
    fbperf.cxx
    ${CMAKE_SOURCE_DIR}/vncviewer/PlatformPixelBuffer.cxx
    ${CMAKE_SOURCE_DIR}/vncviewer/Surface.cxx)
  if(WIN32)
    set(FBPERF_SOURCES ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/Surface_Win32.cxx)
  elseif(APPLE)
    set(FBPERF_SOURCES
        ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/Surface_OSX.cxx
        ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/keysym2ucs.c
        ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/cocoa.mm)
  else()
    set(FBPERF_SOURCES ${FBPERF_SOURCES} ${CMAKE_SOURCE_DIR}/vncviewer/Surface_X11.cxx)
  endif()
  add_executable(fbperf ${FBPERF_SOURCES})
  target_link_libraries(fbperf test_util rfb ${FLTK_LIBRARIES} ${GETTEXT_LIBRARIES})
  if(WIN32)
    target_link_libraries(fbperf msimg32)
  endif()
  if(APPLE)
    target_link_libraries(fbperf "-framework Cocoa")
    target_link_libraries(fbperf "-framework Carbon")
    target_link_libraries(fbperf "-framework IOKit")
  endif()
endif()

=== tests/unit/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/vncviewer)

add_executable(conv conv.cxx)
target_link_libraries(conv rfb)

add_executable(convertlf convertlf.cxx)
target_link_libraries(convertlf rfb)

add_executable(gesturehandler gesturehandler.cxx ../../vncviewer/GestureHandler.cxx)
target_link_libraries(gesturehandler rfb)

add_executable(hostport hostport.cxx)
target_link_libraries(hostport rfb)

add_executable(pixelformat pixelformat.cxx)
target_link_libraries(pixelformat rfb)

add_executable(unicode unicode.cxx)
target_link_libraries(unicode rfb)

add_executable(emulatemb emulatemb.cxx ../../vncviewer/EmulateMB.cxx)
target_link_libraries(emulatemb rfb  ${GETTEXT_LIBRARIES})

=== unix/vncserver/CMakeLists.txt ===
add_executable(vncsession vncsession.c)
target_link_libraries(vncsession ${PAM_LIBS})

configure_file(vncserver@.service.in vncserver@.service @ONLY)
configure_file(vncsession-start.in vncsession-start @ONLY)
configure_file(vncserver.in vncserver @ONLY)
configure_file(vncsession.man.in vncsession.man @ONLY)

install(TARGETS vncsession DESTINATION ${CMAKE_INSTALL_FULL_SBINDIR})
install(FILES tigervnc.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME tigervnc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncsession.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME vncsession.8)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/vncserver DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR})
install(FILES vncserver.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME vncserver.8)
install(FILES vncserver-config-defaults vncserver-config-mandatory DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/tigervnc)

install(FILES vncserver.users DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/tigervnc)

install(FILES HOWTO.md DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})

if(INSTALL_SYSTEMD_UNITS)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/vncserver@.service DESTINATION ${CMAKE_INSTALL_FULL_UNITDIR})
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/vncsession-start DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR})
endif()

=== debian/changelog ===
tigervnc (1.12.0+dfsg-4) unstable; urgency=medium

  * Backported a Debian change applied upstream that provides app stream
    org.tigervnc.xtigervncviewer.metainfo.xml information for the TigerVNC
    viewer.

 -- Joachim Falk <joachim.falk@gmx.de>  Fri, 25 Mar 2022 18:06:01 +0100

tigervnc (1.12.0+dfsg-3) unstable; urgency=medium

  * Fix build with xorg-server-21.1.3 (Closes: #1005664)

 -- Joachim Falk <joachim.falk@gmx.de>  Tue, 15 Feb 2022 20:09:59 +0100

tigervnc (1.12.0+dfsg-2) unstable; urgency=medium

  * Re-upload as-is (and source-only).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 30 Jan 2022 17:40:52 +0100

tigervnc (1.12.0+dfsg-1) unstable; urgency=medium

  [ Joachim Falk ]
  * Fresh upstream TigerVNC 1.12.0 (Closes: #880587, #879866, #855350)
  * Updated app stream org.tigervnc.xtigervncviewer.metainfo.xml information
    file for TigerVNC 1.12.0 release.
  * Adjusted options for tigervncserver and x0tigervncserver to correspond to
    TigerVNC 1.12.0 release.
  * Correctly initialize XDG_SESSION_DESKTOP, XDG_CURRENT_DESKTOP,
    XDG_SESSION_TYPE, and XDG_SESSION_CLASS.
  * Refreshed copyright years and bumped version of man pages.
  * Small content tweak in tigervnc.conf.5x (rfbwait option no longer exists).
  * Split of tigervncpasswd from tigervnc-common into its own tigervnc-tools
    package.
  * Fixed some lintian errors.
  * Bumped Standards-Version: to 4.6.0. No changes were needed.
  * Fixed typo in tigervncserver man page. (Closes: #1003715)
  * Clear session argument from config file if -xstartup specified on the
    command line. (Closes: #1000871)
  * Fixed tigervncserver/x0tigervncserver -list for VNC servers not using a
    rfbport from 5900 to 5999. (Closes: #1004365)
  * Support for -rfbunixpath in tigervncserver and x0tigervncserver wrapper
    scripts. (LP: #1892595)
  * Fixed gnome desktop start up when using tigervncserver@.service.
    (Closes: #1004395)
  * Provided example configuration for tigervnc-xorg-extension. However, this
    is still broken due to bug #855441.
  * Applied the following upstream fixes:
    - a6160b Fix formatting of -rfbport in man pages
    - 2daf41 Fix typo in mirror monitor detection
    - 1a729d Fix handling of VMware cursors
    - 88e96d Fix session resize after mirroring on Linux vncviewer

 -- Joachim Falk <joachim.falk@gmx.de>  Wed, 26 Jan 2022 18:19:38 +0100

tigervnc (1.11.0+dfsg-3) unstable; urgency=medium

  [ Joachim Falk ]
  * Fixed warnings use of uninitialized value in string eq at
    /usr/share/perl5/TigerVNC/Config.pm line 401 or 414. (Closes: #1004366)
  * Fixed debian/watch to again detect upstream versions.
  * Bumped Standards-Version: to 4.5.1. No changes needed.
  * Added org.tigervnc.xtigervncviewer.metainfo.xml for appstream

 -- Joachim Falk <joachim.falk@gmx.de>  Sat, 17 Apr 2021 10:22:50 +0200

=== debian/control ===
Source: tigervnc
Section: x11
Priority: optional
Maintainer: TigerVNC Packaging Team <pkg-tigervnc-devel@lists.alioth.debian.org>
Uploaders:
 Joachim Falk <joachim.falk@gmx.de>,
 Mike Gabriel <sunweaver@debian.org>,
 Yaroslav Halchenko <debian@onerussian.com>,
 Ola Lundqvist <opal@debian.org>,
 Antoni Villalonga <antoni@friki.cat>
# all the Build-Depends up to x11proto-xf86-dri-dev are for the normal Xorg
# server, and common dependencies for the DIX.
# x11proto-xf86dri-dev and libdrm-dev are for DRI support for the Xorg server.
# x11proto-print-dev and libfreetype6-dev are for Xprint
# everything on is for the DMX and Xnest servers.
Build-Depends:
 debhelper-compat (= 12),
 cmake (>= 2.8),
 gettext,
 zlib1g-dev,
 libjpeg-dev,
 libgnutls28-dev,
 libpam0g-dev,
 libxft-dev,
 libxcursor-dev,
 libxrandr-dev,
 libxdamage-dev,
 libwrap0-dev,
 libfltk1.3-dev (>= 1.3.3),
 xorg-server-source (>= 2:21),
 xserver-xorg-dev,
 appstream,
# this are dependencies from xorg-server-21.1.3 source deb
# debhelper-compat (= 12),
 po-debconf,
 quilt,
 pkg-config,
 bison,
 flex,
 xutils-dev (>= 1:7.6+4),
 xfonts-utils (>= 1:7.5+1),
 x11proto-dev (>= 2021.5),
 xtrans-dev (>= 1.3.5),
 libxau-dev (>= 1:1.0.5-2),
 libxcvt-dev,
 libxdmcp-dev (>= 1:0.99.1),
 libxfont-dev (>= 1:2.0.1),
 libxkbfile-dev (>= 1:0.99.1),
 libpixman-1-dev (>= 0.27.2),
 libpciaccess-dev (>= 0.12.901),
 libgcrypt-dev,
 nettle-dev,
 libudev-dev (>= 151-3) [linux-any],
 libselinux1-dev (>= 2.0.80) [linux-any],
 libaudit-dev [linux-any],
 libdrm-dev (>= 2.4.107-5~) [!hurd-i386],
 libgl1-mesa-dev (>= 9.2),
 mesa-common-dev,
# Don't use libunwind for armel, armhf, and arm64 as this library is buggy (bug #923962) on those architectures.
 libunwind-dev [amd64 hppa i386 ia64 mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el sh4],
 libxmuu-dev (>= 1:0.99.1),
 libxext-dev (>= 1:0.99.1),
 libx11-dev (>= 2:1.6),
 libxrender-dev (>= 1:0.9.0),
 libxi-dev (>= 2:1.8),
 libxpm-dev (>= 1:3.5.3),
 libxaw7-dev (>= 1:0.99.1),
 libxt-dev (>= 1:0.99.1),
 libxmu-dev (>= 1:0.99.1),
 libxtst-dev (>= 1:0.99.1),
 libxres-dev (>= 1:0.99.1),
 libxfixes-dev (>= 1:3.0.0),
 libxv-dev,
 libxinerama-dev,
 libxshmfence-dev (>= 1.1) [!hurd-i386],
# glamor
 libepoxy-dev [linux-any kfreebsd-any],
 libegl1-mesa-dev [linux-any kfreebsd-any],
 libgbm-dev (>= 10.2) [linux-any kfreebsd-any],
## XCB bits for Xephyr
# libx11-xcb-dev,
# libxcb1-dev,
# libxcb-xkb-dev,
# libxcb-shape0-dev,
# libxcb-render0-dev,
# libxcb-render-util0-dev,
# libxcb-util0-dev,
# libxcb-image0-dev,
# libxcb-icccm4-dev,
# libxcb-shm0-dev,
# libxcb-keysyms1-dev,
# libxcb-randr0-dev,
# libxcb-xv0-dev,
# libxcb-glx0-dev,
# libxcb-xf86dri0-dev (>= 1.6),
# unit tests
 xkb-data,
 x11-xkb-utils,
# arc4random_buf(), getpeereid()
 libbsd-dev,
#logind
  libdbus-1-dev (>= 1.0) [linux-any],
# systemd-daemon
  libsystemd-dev [linux-any],
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian-remote-team/tigervnc.git
Vcs-Browser: https://salsa.debian.org/debian-remote-team/tigervnc
Homepage: http://www.tigervnc.org

Package: tigervnc-common
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Virtual network computing; Common software needed by servers
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides the common infrastructure for the
 tigervnc-scraping-server and the tigervnc-standalone-server packages and the
 vncconfig tool, which should run in the `desktop' environment served by the
 VNC server.

Package: tigervnc-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Replaces:
 tigervnc-common (<< 1.12)
Breaks:
 tigervnc-common (<< 1.12)
Description: Virtual network computing; Tools for both clients and servers
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides the vncpasswd tool.

Package: tigervnc-scraping-server
Architecture: any
Depends:
 tigervnc-common (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libfile-readbackwards-perl (>= 1.05)
Recommends:
 tigervnc-tools (= ${binary:Version})
Suggests:
 openssl
Provides:
 vnc-server
Description: Virtual network computing server performing X screen scraping
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides a VNC server that perform screen scraping of an already
 running X server to provide its VNC desktop. The VNC desktop can be viewed
 by any VNC viewer even on other operating systems.
 .
 Note: If you only want to scrape your local X11 server, you should consider
 the tigervnc-xorg-extension package. This package provides the vnc extension
 for your local X11 server. The usage of this extension is more efficient
 than a scraping vnc server.

Package: tigervnc-standalone-server
Architecture: any
Depends:
 xkb-data,
 x11-xkb-utils,
 xauth,
 tigervnc-common (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libfile-readbackwards-perl (>= 1.05)
Recommends:
 tigervnc-tools (= ${binary:Version}),
 libgl1-mesa-dri (>= 7.1~rc1),
 xfonts-base,
 x11-xserver-utils
Suggests:
 xfonts-100dpi | xfonts-75dpi,
 xfonts-scalable,
 openssl
Provides:
 vnc-server,
 xserver
Description: Standalone virtual network computing server
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides a standalone VNC server to which clients can connect.
 The server generates a display that can be viewed with a vncviewer.
 .
 Note: This server does not need a display. You need a VNC viewer to see
 something. This viewer may also be on a computer running other operating
 systems.

Package: tigervnc-xorg-extension
Architecture: any
Depends:
 xserver-xorg-core (>= 2:1.7.7),
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 tigervnc-tools (= ${binary:Version}),
 tigervnc-common (= ${binary:Version})
Provides:
 vnc-server,
 vnc-xorg-extension
Description: Virtual network computing X server extension
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package contains an X server connector so VNC clients can connect to your
 local X desktop directly.

Package: tigervnc-viewer
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 tigervnc-tools (= ${binary:Version})
Provides:
 vncviewer,
 vnc-viewer
Description: Virtual network computing client for X
 VNC stands for Virtual Network Computing. It is, in essence, a remote display
 system that allows you to view a computing `desktop' environment not only on
 the machine where it is running but from anywhere on the Internet and from a
 wide variety of machine architectures. For this purpose, it implements a
 client/server model.
 .
 This package provides a VNC client for X. With this you can connect to a
 VNC server and display its content. There are VNC servers available for other
 operating systems.

#Package: tigervnc-java
#Architecture: all
#Depends:
# openjdk-7-jre
#Provides:
# vnc-java-viewer
#Enhances:
# tigervnc-standalone-server
#Description: Virtual network computing java applet and command line program
# VNC stands for Virtual Network Computing. It is, in essence, a remote
# display system which allows you to view a computing `desktop' environment
# not only on the machine where it is running, but from anywhere on the
# Internet and from a wide variety of machine architectures.
# .
# It contains a java viewer implementation that can either be used as an applet,
# typically served by the built in web server provided by Xvnc
# (tigervnc-standalone-server) or from command line using a Java JRE.

=== debian/watch ===
version=3
opts="repack,repacksuffix=+dfsg,compression=xz,dversionmangle=s/\+dfsg$//,filenamemangle=s/.*v([\d\.]+)\..*/tigervnc_$1.orig.tar.gz/" \
 https://github.com/TigerVNC/tigervnc/releases .*/archive/refs/tags/v([\d\.]+)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
